# GoDoor

Go rewrite of [kdoorpi](https://git.k-space.ee/arti/kdoorpi). Uses
[libgpiod](https://git.kernel.org/pub/scm/libs/libgpiod/libgpiod.git/about/)
native Go library to access the general purpose pins in cross platform way.

# Developing

Either build directly on Raspberry Pi or build locally and copy the binary

```
GOOS=linux GOARCH=arm64 go build
scp godoor rpi4b:
```

## Cross platform buils with containerd/nerdctl

    sudo nerdctl build --tag godoor --output type=oci --platform linux/amd64,linux/arm64 .

Nerdctl needs `type=oci` passed to its BuildKit backend, otherwise it will build a legacy Docker image.

# Deployment

The CI system should automatically build docker image and push it to [Harbor](https://harbor.k-space.ee)

Refer to
[Ansible playbook](https://git.k-space.ee/k-space/kube/src/branch/master/ansible-doors.yml)
on how to deploy on all door controllers

# Usage

For end users door can be opened by:

* [Web interface](https://inventory.k-space.ee/m/doorboy)
  * Push button
  * Enrolling keyfob and swiping keyfob at door cardreader
* Issuing `/open-...-door` command in #members channel

For emergency cases:

* Log into door controller via SSH and issue `killall -sUSR1 godoor`
